import java.awt.*;
import javax.swing.*;
import java.awt.geom.*;
import java.util.ArrayList;
import java.lang.Thread;


public class GlosMap extends JLabel{

	private String[][] mapCoords = {
								//Hovedbygningen
								{"Hvedbygningen", "219", "116"},
								{"Hovedgygget", "219", "116"},
								{"Hovedbygn.st", "219", "116"},
								{"Hovedbygningen", "219", "116"},
								{"Hovedbygningen306B", "219", "116"},
								{"Hovedbygn.", "219", "116"},
								{"Hovedbygn", "219", "116"},
								{"Hovedbyggningen", "219", "116"},
								{"Hovedbygget", "219", "116"},
								{"Hovedbygget 2 etg.", "219", "116"},
								{"Hovedbygg", "219", "116"},
								{"Hovedb.4etg.", "219", "116"},

								//Sentralbygg
								{"Stripa", "216", "313"},
								{"Sentralbygg 1", "216", "313"},
								{"Sentralbygg I", "216", "313"},
								{"Sentrbygg I", "216", "313"},
								{"SEntralbygg", "216", "313"},
								{"Sentralbygg", "216", "313"},
								{"Sentralbygg ", "216", "313"},
								{"Sentralbygg 2", "217", "266"},
								{"Sentralbygg II", "217", "266"},

								//Varmeteknisk
								{"Varmetek Lab", "264", "159"},
								{"Varmet.lab" , "245", "149"},
								{"Varmetekn.lab" , "245", "149"},
								{"Varmetekn Lab" , "245", "149"},
								{"Varmeteknisk lab" , "245", "149"},
								{"Varmeteknisk Lab 4.etg" , "245", "149"},
								{"Varmeteknikk" , "245", "149"},
								{"Varmetekn." , "245", "149"},
								{"Varmetek Lab" , "245", "149"},

								//IT syd
								{"IT-bygg syd", "155", "334"},

								//Kjel
								{"VTL, Kjelhuset", "273","181"},
								{"Kjelhuset", "273","181"},
								{"Kjelhus", "273","181"},

								//Gamle kjemi
								{"Gamle Kjemi", "214", "215"},
								{"Gamle kjemi", "214", "215"},
								{"Gml.kjemi", "214", "215"},

								//Gamle fysikk
								{"Gml.Fysikk", "172", "291"},
								{"Gml.fysikk", "172", "291"},
								{"Gml fysikk", "172", "291"},
								{"Gl. Fysikk", "172", "291"},
								{"Gl.fysikk", "172", "291"},
								{"G-fysikk", "172", "291"},
								{"G-Fysikk", "172", "291"},
								{"Gamle fysikkt", "172", "291"},
								{"Gamle fysikk 3. etg.", "172", "291"},
								{"Gamle Fysikk", "172", "291"},
								{"Gamle fysikk", "172", "291"},
								{"Gamle fysik", "172", "291"},

								//Strmningsteknikk
								{"Strmninksteknikk", "282", "217"},
								{"Strmningstekn.lab", "282", "217"},
								{"Strmningsteknisk lab", "282", "217"},
								{"Strmningsteknikk", "282", "217"},
								{"Strmningstekn", "282", "217"},
								{"Strmningslab.", "282", "217"},
								{"Strminsteknisk", "282", "217"},

								//Elektro
								{"Elektro A", "160", "166"},
								{"Elektroblokk A", "160", "166"},
								{"ElektroblokkA", "160", "166"},
								{"Elektro B", "117", "152"},
								{"Elektro B II", "117", "152"},
								{"Elektro b", "117", "152"},
								{"Elekstro B", "117", "152"},
								{"Elektroblokk B", "117", "152"},
								{"Elektro C", "118", "130"},
								{"Elektro D", "93", "129"},
								{"Elektroblokk D", "93", "129"},
								{"Elektro E", "168", "203"},
								{"Elektro E-blokk", "168", "203"},
								{"Elektro F", "167", "219"},
								{"Elktro F", "167", "219"},
								{"Elektro G", "183", "192"},

								//Sintef Energi
								{"SINTEF Energiforskning", "147", "250"},
								{"SINTEF Energiforsk", "147", "250"},
								{"Sintef Energiforsk", "147", "250"},

								//Realfagbygget
								{"Realfgbygget", "208", "443"},
								{"Realfagsbygget", "208", "443"},
								{"Realfagsbygg", "208", "443"},
								{"Realfag", "208", "443"},
								{"Realfagbygg", "208", "443"},
								{"Realfagbyggg", "208", "443"},
								{"Realfagbygget", "208", "443"},
								{"REALFAGBYGG", "208", "443"},
								{"Real", "208", "443"},
								{"Ralfagsbygget", "208", "443"},

								{"Stra", "115", "88"},

								//Kjemi 1
								{"Kjemi", "148", "389"},
								{"Kjemihall, R25", "148", "389"},
								{"Kjemihall", "148", "389"},
								{"Kjemihallen", "148", "389"},
								{"Kjemiblokk I", "148", "389"},

								//Kjemi 2
								{"Kjemi II Vrimlehall", "172", "389"},
								{"Kjemi II-IIi", "172", "389"},
								{"Kjemi II", "172", "389"},
								{"Kjemiblokk II", "172", "389"},

								//Kjemi 3
								{"Kjemi III/IV", "201", "389"},
								{"Kjemi III", "201", "389"},
								{"Kjemiblokk III", "201", "389"},
								{"Kjemiblokk III-IV", "201", "389"},
								{"Kjemiblokk 3", "201", "389"},
								{"Kjemibl.iii", "201", "389"},

								//Kjemi 4
								{"Kjemi mellombygg 4/5", "226", "389"},
								{"Kjemi IV", "226", "389"},
								{"Kjemiblokk IV", "226", "389"},
								{"Kjemiblokk 4", "226", "389"},
								{"Kjemi 4", "226", "389"},

								//Kjemi 5
								{"Kjemi V", "253", "389"},
								{"Kjemihall V", "253", "389"},
								{"Kjemiblokk V", "253", "389"},
								{"Kjemiblokk 5", "253", "389"},
								{"Kjemiblokk 5-407", "253", "389"},
								{"Kjemi 5", "253", "389"},

											};

	ImageIcon it3;
	private Ellipse2D.Double circle;
	private Ellipse2D.Double startDot;
	private Line2D.Double youreHereLine;
	private Line2D.Double goalLine;

	private ArrayList pathList;
	private int goalText_y;
	private boolean buildingFound = false;

	public GlosMap(String building){
		super(new ImageIcon("gloshaugen.gif"));
		int[] locationCoords = new int[2];
		for(int i=0; i<mapCoords.length; i++){
			if( ((String)mapCoords[i][0]).equals(building)){
				locationCoords[0] = Integer.parseInt(mapCoords[i][1]);
				locationCoords[1] = Integer.parseInt(mapCoords[i][2]);
				buildingFound = true;
			}
		}
		if(buildingFound) setLocationCircle(locationCoords[0]-25,locationCoords[1]-15);
		startDot = new Ellipse2D.Double(140,304,10,10);
		youreHereLine = new Line2D.Double(145,309,600,309);
	}

	//Dummy constructor
	public GlosMap(){

	}

	public boolean buildingOnGlos(String s){
		for(int i=0; i<mapCoords.length; i++){
			if(s.equals(mapCoords[i][0])) return true;
		}
		return false;
	}

	public void paintComponent(Graphics g){
		clear(g);
		Graphics2D g2d = (Graphics2D)g;
		g2d.setColor(Color.red);
		if(buildingFound){
			g2d.draw(circle);
			g2d.draw(goalLine);
			g2d.drawString("Du skal hit!", 550, goalText_y);
		}
		g2d.fill(startDot);
		g2d.draw(youreHereLine);
		g2d.drawString("Du er her!", 550, 300);
	}

	public void setLocationCircle(int x, int y){
		circle = new Ellipse2D.Double(x,y,50,30);
		goalLine = new Line2D.Double(x+50, y+15, 600, y+15);
		goalText_y = y+5;
	}

	protected void clear(Graphics g){
		super.paintComponent(g);
	}

	protected Ellipse2D.Double getCircle(){
		return (circle);
	}
}